include \masm32\MasmBasic\MasmBasic.inc
Ticks2FPU MACRO
	mov edx, 7FFE0008h	; aka [url=http://www.nirsoft.net/kernel_struct/vista/KUSER_SHARED_DATA.html]KUSER_SHARED_DATA.InterruptTime.High1Time[/url]
 @@:	mov eax, [edx+4]
	cmp eax, [edx+8]	; See [url=http://www.dcl.hpi.uni-potsdam.de/research/WRK/2007/08/getting-os-information-the-kuser_shared_data-structure/]Windows Research Kernel @ HPI[/url] and look for consistent
	jne @B
	fild qword ptr [edx]
ENDM

OneEm9	REAL10 100.0E-9

	Init
	mov ecx, 16
	.Repeat
		Ticks2FPU
		For_ n=1 To 65
			push ecx
			dec ecx
			invoke Sleep, ecx
			pop ecx
			fld st
			Ticks2FPU
			fsub
			fchs
			fld OneEm9
			fmul
			Print Str$("Loop %i  \t", n), Str$("%If\n", ST(0))
			fstp st
		Next
		Inkey Str$("Sleep %i - one more? Esc=exit\n", ecx-1)
		add ecx, ecx
	.Until eax==VK_ESCAPE
	Exit
end start


KSYSTEM_TIME STRUCT
LowPart	ULONG ?		; Long is 4 bytes
High1Time	LONG ?		; UsedTime
High2Time	LONG ?
KSYSTEM_TIME ENDS


OPT_Tmp2Asm	1
OPT_DebugA	/Zi	; activate symbols
	OPT_Assembler	mlv615	; must be present in \bin
	OPT_DebugL	/debug /debugtype:cv	; for debugging
	OPT_Linker	linkv614	; must be present in \bi



Loop 1          0.0156250000000000000
Loop 8          0.125000000000000000
Loop 32         0.500000000000000000
Loop 64         1.00000000000000000
